package cn.ibizlab.core.uaa.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.uaa.domain.SYS_ROLE_PERMISSION;
import cn.ibizlab.core.uaa.filter.SYS_ROLE_PERMISSIONSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface SYS_ROLE_PERMISSIONMapper extends BaseMapper<SYS_ROLE_PERMISSION>{

    Page<SYS_ROLE_PERMISSION> searchDefault(IPage page, @Param("srf") SYS_ROLE_PERMISSIONSearchContext context, @Param("ew") Wrapper<SYS_ROLE_PERMISSION> wrapper) ;
    @Override
    SYS_ROLE_PERMISSION selectById(Serializable id);
    @Override
    int insert(SYS_ROLE_PERMISSION entity);
    @Override
    int updateById(@Param(Constants.ENTITY) SYS_ROLE_PERMISSION entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql);

    List<SYS_ROLE_PERMISSION> selectByPermissionid(@Param("permissionid") Serializable permissionid) ;

    List<SYS_ROLE_PERMISSION> selectByRoleid(@Param("roleid") Serializable roleid) ;

}
